regina::GluingPermSearcher< 4 >::PentTriangleState Struct Reference
Census of Triangulations

A structure used to track equivalence classes of pentachoron triangles as the gluing permutation set is constructed. More...

`#include <census/gluingpermsearcher4.h>`

## Public Member Functions

| PentTriangleState ()
| Constructor for a standalone pentachoron triangle in an equivalence class all of its own. More...
void | dumpData (std::ostream &out) const
| Dumps all internal data in a plain text format to the given output stream. More...
bool | readData (std::istream &in, unsigned long nStates)
| Fills this state with data read from the given input stream. More...

## Public Attributes

int | parent
| The index of the parent object in the current tree, or -1 if this object is the root of the tree. More...
unsigned | rank
| The depth of the subtree beneath this object (where a leaf node has depth zero). More...
unsigned | size
| The total number of objects in the subtree descending from this object (where this object is counted also). More...
bool | bounded
| Does this equivalence class of pentachoron triangles represent a boundary triangle? More...
Perm< 3 > | twistUp
| The vertices of each pentachoron triangle can be labelled (0,1,2) by running through the underlying pentachoron vertices from smallest index to largest index. More...
bool | hadEqualRank
| Did this tree have rank equal to its parent immediately before it was grafted beneath its parent? This information is used to maintain the ranks correctly when grafting operations are undone. More...

## Detailed Description

### template<>
struct regina::GluingPermSearcher< 4 >::PentTriangleState

A structure used to track equivalence classes of pentachoron triangles as the gluing permutation set is constructed.

Two triangles are considered equivalent if they are identified within the 4-manifold triangulation.

Pentachoron triangles are indexed linearly by pentachoron and then triangle number. Specifically, triangle f (0..9) of pentachoron p (0..nPents-1) has index 10p+f.

Each equivalence class of triangles corresponds to a tree of PentTriangleState objects, arranged to form a modified union-find structure.

The documentation for this struct was generated from the following file:

- census/gluingpermsearcher4.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).